<?php

namespace Drupal\activitypub\Entity\Storage;

use Drupal\Core\Entity\ContentEntityStorageInterface;

/**
 * Defines an interface for ActivityPub activity entity storage class.
 */
interface ActivityPubActivityStorageInterface extends ContentEntityStorageInterface {

  /**
   * Get activities.
   *
   * @param array $conditions
   *
   * @return \Drupal\activitypub\Entity\ActivityPubActivityInterface[]
   */
  public function getActivities($conditions = []);

  /**
   * Get activity count.
   *
   * @param array $conditions
   *
   * @return int
   */
  public function getActivityCount($conditions = []);

  /**
   * Chang read status in inbox.
   *
   * @param $status
   *   The status to update to.
   */
  public function changeReadStatus($status);

}
