<?php

namespace Drupal\activitypub\Services;

use Drupal\activitypub\Entity\ActivityPubActivityInterface;

interface ActivityPubProcessClientInterface {

  /**
   * Handles the Outbox queue.
   *
   * @param bool $send
   *   Whether to send to inboxes.
   * @param bool $remove_item_from_queue
   *   Whether to remove the item from the queue.
   * @param bool $debug
   *   Whether to view debug statements, useful when using Drush.
   */
  public function handleOutboxQueue($send = TRUE, $remove_item_from_queue = TRUE, $debug = FALSE);

  /**
   * Handles the Inbox queue.
   *
   * @param bool $remove_item_from_queue
   *   Whether to remove the item from the queue.
   * @param false $debug
   *   Whether to view debug statements, useful when using Drush.
   */
  public function handleInboxQueue($remove_item_from_queue = TRUE, $debug = FALSE);

  /**
   * Generates a queue item.
   *
   * @param \Drupal\activitypub\Entity\ActivityPubActivityInterface $activityPubActivity
   */
  public function createQueueItem(ActivityPubActivityInterface $activityPubActivity);

}
