<?php

namespace Drupal\Tests\activitypub\Functional;

use Drupal\Core\Url;

/**
 * Tests Webfinger functionality.
 *
 * @group activitypub
 */
class WebfingerTest extends ActivityPubTestBase {

  /**
   * Test webfinger response.
   *
   * @throws \Behat\Mink\Exception\ExpectationException
   */
  public function testWebfingerResponse() {
    $assert_session = $this->assertSession();
    $page = $this->getSession()->getPage();

    $this->enableActivityPub($assert_session);
    $this->drupalLogout();

    $this->drupalGet('.well-known/webfinger');
    $assert_session->statusCodeEquals(404);
    $assert_session->responseHeaderContains('Content-Type', 'application/jrd+json; charset=utf-8');

    $resource = $this->getResourceUrl($this->accountNameOne);
    $this->drupalGet('.well-known/webfinger', ['query' => ['resource' => $resource]]);
    $assert_session->statusCodeEquals(200);
    $content = json_decode($page->getContent());
    self::assertEquals(Url::fromRoute('entity.user.canonical', ['user' => $this->authenticatedUserOne->id()], ['absolute' => TRUE])->toString(), $content->aliases[0]);

    $resource = $this->getResourceUrl($this->accountNameOne, FALSE);
    $this->drupalGet('.well-known/webfinger', ['query' => ['resource' => $resource]]);
    $assert_session->statusCodeEquals(200);
    $content = json_decode($page->getContent());
    self::assertEquals(Url::fromRoute('entity.user.canonical', ['user' => $this->authenticatedUserOne->id()], ['absolute' => TRUE])->toString(), $content->aliases[0]);
  }

}
